/*
 * userlist.c v1.2
 * for use with Citadel/UX
 * see copyright.doc for copyright information
 */

#include <stdio.h>
#include <fcntl.h>
#include <pwd.h>
#include <ctype.h>
#include <time.h>
#include "citadel.h"

struct passwd *getpwnam();
struct tm *localtime();
long atol();

main(argc,argv)
int argc;
char *argv[];
 {
int a,b,c,file,pass;
char aaa[100];
long aa,snum;
struct usersupp usersupp;
struct tm *tmstruct;
pass=0; snum=(-1L);
for (a=1; a<argc; ++a) if (!strcmp(argv[a],"-p")) pass=1;
for (a=1; a<argc; ++a) if (!strcmp(argv[a],"-n")) snum=atol(argv[a+1]);

a=getuid();
if ((a!=0)&&(a!=9)) pass=0;
/* remove these two lines or change to user id's of people allowed
 * to read the users' passwords.
 */

file=open("usersupp",O_RDONLY);
if (file<0) {
	printf("No usersupp file available.\n");
	exit(1); }

printf("    User Name        Number LastCall Col #Calls Posted ");
if (pass) printf("Password");
printf("\n");
printf("-------------------- ------ -------- --- ------ ------ ");
if (pass) printf("-------------------");
printf("\n");
A:	a=read(file,&usersupp,sizeof(struct usersupp));
	if (a<1) goto END;
	for (b=0; b<strlen(usersupp.fullname); ++b) {
		if (usersupp.fullname[b]<32) usersupp.fullname[b]='.';
		if (usersupp.fullname[b]>126) usersupp.fullname[b]='.'; }
	if (snum!=(-1L)) {
		if ((pass==0)&&(((usersupp.flags&US_UNLISTED)==US_UNLISTED)))
			goto A;
		}
	if ((snum!=(-1L))&&(snum!=usersupp.eternal)) goto A;
		
	aa=usersupp.lastcall;
	tmstruct=localtime(&aa);
	sprintf(aaa,"%2d/%2d/%2d",
		(tmstruct->tm_mon+1),
		tmstruct->tm_mday,
		tmstruct->tm_year);
	usersupp.fullname[20]=0;

	a=48+usersupp.axlevel;
	printf("%-20s%c%6ld %6s %3d %6d %6d ",
		usersupp.fullname,a,
		usersupp.eternal,
		aaa,
		usersupp.screenwidth,
		usersupp.timescalled,
		usersupp.posted
		);
	pwcrypt(usersupp.password,PWCRYPT);
	if (pass) printf("%s",usersupp.password);
	printf("\n");
	goto A;

END:	close(file);
	exit(0);
}

pwcrypt(text,code)
char text[];
int code; {
	int a;
	for (a=0; a<strlen(text); ++a) text[a]=(text[a]^(((code|128)^a)&0xFF));
	return(0);
	}
