/*
 * Citadel/UX "who is logged in" report
 * see copyright.doc for copyright information
 * v1.0
 */

#include <fcntl.h>
#include <pwd.h>
#include "citadel.h"

struct passwd *getpwnam();

struct utmp {
	char	ut_line[8];		/* tty name */
	char	ut_name[8];		/* user id */
	long	ut_time;		/* time on */
};

main() {
	struct utmp utmp;
	int file,wfile,a;
	struct passwd *pwbuf;
	char name[30];
	struct wtmpsupp wtmpsupp;

	chdir(BBSDIR);
	printf(" Port   Name\n");
	printf("------- ----\n");
	file=open("/etc/utmp",O_RDONLY);
	while ((read(file,&utmp,sizeof(struct utmp)))) {
		if (utmp.ut_name[0]!=0) {
			pwbuf=getpwnam(utmp.ut_name);
			strcpy(name,pwbuf->pw_gecos);

if ((pwbuf->pw_uid)==BBSUID) {
	strcpy(name,"<not logged in>");
	wfile=open("wtmpsupp",O_RDONLY);
	do {
		a=read(wfile,&wtmpsupp,sizeof(struct wtmpsupp));
		if (!strcmp(&wtmpsupp.WStty[5],utmp.ut_line))
			strcpy(name,wtmpsupp.WSname);
		} while((a>0)&&(strcmp(&wtmpsupp.WStty[5],utmp.ut_line)));
		close(wfile);
	}

	printf("%-7s %s\n",utmp.ut_line,name);
		}
	}
	close(file);
	exit(0);
}
